#include <iostream>
#include <fstream>
#include <string>
#include <ctime>

using namespace std;

class CMemoBlock {
private:
  string filename;
  inline void openError();
  inline void writeError();
  inline void readError();
  void schreiben();
  void lesen();
  void loeschen();

public:
  CMemoBlock();
  ~CMemoBlock();
  void setfilename( string _filename );
  void menu();
};



inline void CMemoBlock::openError() {
  cerr << "Fehler beim Oeffnen der Datei " << filename << endl; 
  exit( 1 ); 
}

inline void CMemoBlock::writeError() {
  cerr << "Fehler beim Schreiben in die Datei " << filename << endl; 
  exit( 2 );
}

inline void CMemoBlock::readError() {
  cerr << "Fehler beim Lesen der Datei " << filename << endl; 
  exit( 3 ); 
}

void CMemoBlock::schreiben() {
  string line, zeit;

  fstream memoFile( filename.c_str(), ios::out | ios::app );

  if( !memoFile ) {
    openError();
  }

  time_t sec = time( NULL );
  zeit = ctime( &sec ); 
  zeit.erase( zeit.length()-1, 1 );
	
  cout << "Geben Sie Ihre Notiz ein:\n";
  getline( cin, line ); 

  if( !( memoFile << zeit << ": " << line << endl ) ) {
    writeError();
  }

  memoFile.close();
}

void CMemoBlock::lesen() {
  string line;
  int number = 0;

  fstream memoFile( filename.c_str(), ios::in );

  if( !memoFile ) {
    openError();
  }

  while( getline( memoFile, line ) )	{
    cout.width( 5 ); 
    cout << ++number << ": " << line << endl;
  }

  if( !memoFile.eof() ) {
    readError();
  }

  memoFile.close();
}

void CMemoBlock::loeschen() {
  fstream memoFile( filename.c_str(), ios::out );

  if( !memoFile ) {
    openError();
  }

  memoFile.close() ;
}

CMemoBlock::CMemoBlock() {
}

CMemoBlock::~CMemoBlock() {
}

void CMemoBlock::setfilename( string _filename ) {
  filename = _filename;
}


void CMemoBlock::menu() {
  char auswahl = 'a';

  do {
    cout << endl;
	cout << "Memoblock" << endl;
	cout << "---------" << endl << endl;
	cout << "(N)eues Memo hinzufuegen" << endl;
	cout << "(V)orhandene Memosausgeben" << endl;
	cout << "(L)oechen der Memodatei" << endl;
	cout << "(E)nde" << endl;
	cout << "bitte auswaehlen:";
	cin >> auswahl;
	cin.sync();
		
	switch( auswahl ) {
      case 'N': 
	  case 'n': schreiben(); break;
	  case 'V': 
	  case 'v': lesen(); break;
	  case 'L': 
	  case 'l': loeschen(); break;
	  case 'e': 
	  case 'E': break;
	  default: cout << "Keine gltige Eingabe!";
	}
  } while( auswahl != 'e' && auswahl != 'E' );
}


int main() {
  CMemoBlock Memo;

  Memo.setfilename( "memo.txt" );

  Memo.menu();

  return 0;
}

