//--------------------------------------------------
//Headerfile: Studentenverwaltung.cpp
//Beschreibung: Studentendatenbank OOP
//Autor:  Harald Bucher, ITIV
//Erstellt: 20.06.2014
//Version: 1.0
//--------------------------------------------------

#include "Studentenverwaltung.h"
#include <iomanip>

void Studentenverwaltung::addStudent( const string& vorname, const string& name, int matr, double note ) {
	
	Student s;
	s.setData( vorname, name, matr, note );
	studentenliste.push_back( s );
	
	/*
	Student* s = new Student;
	s->setData( vorname, name, matr, note );
	studentenliste.push_back( *s );
	*/
}


list<Student>::iterator Studentenverwaltung::findStudent( const string& name ) {
	list<Student>::iterator it;
	for ( it = studentenliste.begin(); it != studentenliste.end(); ++it ) {
		if ( it->getName() == name ) {
			return it;
		}
	}

	return studentenliste.end();
}


list<Student>::iterator Studentenverwaltung::findStudent( const string& vorname, const string& name ) {
	list<Student>::iterator it = findStudent( name );
	if ( it != studentenliste.end() ) {
		for ( it = studentenliste.begin(); it != studentenliste.end(); ++it ) {
			if ( it->getVorname() == vorname ) {
				return it;
			}
		}
	}

	return studentenliste.end();
}


list<Student>::iterator Studentenverwaltung::findStudent( int matrikel ) {
	list<Student>::iterator it;
	for ( it = studentenliste.begin(); it != studentenliste.end(); ++it ) {
		if ( it->getMatrikelnr() == matrikel ) {
			return it;
		}
	}

	return studentenliste.end();
}


void Studentenverwaltung::deleteStudent( list<Student>::iterator it ) {
	if ( it != studentenliste.end() ) {
		studentenliste.erase(it);
	} else {
		cout << "Student nicht gefunden" << endl;
	}
}


void Studentenverwaltung::printStudent( list<Student>::iterator it ) const {
	if ( it != studentenliste.end() ) {
		cout << "Vorname: " << it->getVorname() << endl 
		<< ", Name: " << it->getName() << endl 
		<< ", Matrikel-Nr.: " << it->getMatrikelnr() << endl 
		<< ", Note: "  << it->getNote() << endl; 
	} else {
		cout << "Student nicht gefunden" << endl;
	}
}

void Studentenverwaltung::print() {
   cout << endl << setw( 12 ) << "Name" << setw( 12 ) << "Vorname" << setw( 12 ) 
        << "Matrikelnr" << setw( 12 ) << "Note" << endl;
   cout << "---------------------------------------------------------------" << endl;

   list<Student>::iterator it;

   if ( ! studentenliste.empty() ) {   
	   for ( it = studentenliste.begin(); it != studentenliste.end(); ++it ) {
			cout << setw( 12 ) << it->getName() << setw( 12 ) 
			<< it->getVorname() << setw( 12 )
			<< it->getMatrikelnr() << setw( 12 ) 
			<< it->getNote() << endl; 
		}
   } else {
		cout << "Die Datenbank ist leer!" << endl;
   }
}


